/**
 * Test case for apemanScff.
 * Runs with mocha.
 */
'use strict'

const apemanScff = require('../lib/apeman_scff.js')
const assert = require('assert')
const co = require('co')
const fs = require('fs')

describe('apeman-scff', () => {
  let tmpDir = `${__dirname}/../tmp`

  it('List types.', () => co(function * () {
    yield apemanScff({})
  }))

  it('Apply scaffold', () => co(function * () {
    let dest = tmpDir + '/foo/bar'
    let tmpl = `${__dirname}/../doc/mocks/mock-scaffold`

    yield apemanScff(tmpl, dest, {
      straight: true,
      force: true
    })
  }))


  it('Apply invalid scaffold', () => co(function * () {
    let dest = tmpDir + '/foo/bar'

    yield apemanScff('__invalid_tmpl_name', dest, {
      straight: true,
      force: true
    }).catch((err) => {
      assert.ok(!!err)
    })

    let data = JSON.parse(
      fs.readFileSync(tmpDir + '/foo/bar/package.json')
    )
    assert.deepEqual(data, {
      foo: 'bar'
    })
  }))
})

/* global describe, it */
